require 'dry-validation'
require 'edgycircle_toolbox/has_attributes'

module EdgycircleToolbox
  module CQRS
    module Command
      module ClassMethods
        def schema(&block)
          if block_given?
            base = Dry::Validation.Schema(build: false) do
              required(:id).filled(:str?)
            end

            @schema = Dry::Validation.Form(rules: base.rules, &block)
          else
            @schema
          end
        end
      end

      def self.included(base)
        base.extend(ClassMethods)
        base.include(HasAttributes)

        base.class_eval do
          attributes :id
        end
      end
    end
  end
end
