module EdgycircleToolbox
  module CQRS
    class CommandResult
      attr_reader :command, :errors, :events

      def initialize(command = nil)
        @command = command
        @events = []
        @errors = []
      end

      def add_error(error)
        errors << error
        self
      end

      def add_event(event)
        events << event
        self
      end

      def set_command(command)
        @command = command
        self
      end

      def failure?
        errors.size > 0
      end
    end
  end
end

