require 'dry-container'

module EdgycircleToolBox
  module CQRS
    class MessageBus
      extend Dry::Container::Mixin

      configure do |config|
        config.registry = ->(container, key, item, options) { (container[key] ||= []).push(item) }
        config.resolver = ->(container, key) { container[key] || [] }
      end

      def self.subscribe(events, callable)
        events.each { |event| register(event, callable) }
      end

      def self.publish(event)
        resolve(event.class).each { |callable| callable.call(event) }
      end
    end
  end
end
