require 'dry-container'

module EdgycircleToolbox
  module CQRS
    class ModelCollector
      extend Dry::Container::Mixin

      configure do |config|
        config.registry = ->(container, key, item, options) { (container[key] ||= []).push(item) }
        config.resolver = ->(container, key) { container[key] || [] }
      end

      def self.for_events(events)
        events.map { |event| resolve(event.class).map { |callable| callable.call(event) } }.flatten
      end
    end
  end
end
