module EdgycircleToolbox
  module HasAttributes
    module ClassMethods
      def attributes(*attributes)
        @attributes ||= []

        return @attributes unless attributes.any?

        attributes.each do |attribute|
          define_attr_accessor(attribute)
          @attributes << attribute
        end
      end

      def define_attr_accessor(attribute)
        attr_accessor(attribute)
      end
    end

    def self.included(base)
      base.class_eval do
        extend ClassMethods
      end
    end

    def initialize(attributes = {})
      attributes.each do |key, value|
        setter = "#{key}="
        public_send(setter, value) if respond_to?(setter)
      end
    end

    def attributes
      self.class.attributes
    end
  end
end
