module EdgycircleToolbox
  module Sonapi
    class Blueprint
      attr_accessor :type, :attribute_names, :dynamic_attributes, :parameter_filter

      def initialize(type, attribute_names = [])
        @type = type
        @attribute_names = attribute_names
        @dynamic_attributes = Proc.new { [] }
        @parameter_filter = Proc.new do |name, value|
          @attribute_names.include?(name.to_s) || name == :id
        end
      end

      def add_attribute(attribute_name)
        @attribute_names << attribute_name
      end

      def attribute_names(object)
        @attribute_names + dynamic_attributes.call(object).map(&:to_s)
      end

      def deserialize_parameter?(name, value)
        parameter_filter.call(name, value)
      end
    end
  end
end
