module EdgycircleToolbox
  module Sonapi
    class Deserializer
      attr_reader :blueprint

      def initialize(blueprint)
        @blueprint = blueprint
      end

      def call(parameters)
        Hash[
          filter_parameter_pairs(parameter_pairs(parameters))
        ]
      end

      private
      def parameter_pairs(parameters)
        id_pair = [:id, parameters["data"]["id"]]

        parameters["data"]["attributes"].to_a.map do |pair|
          [format_attribute_name(pair[0]), pair[1]]
        end << id_pair
      end

      def format_attribute_name(attribute_name)
        attribute_name.to_s.gsub("-", "_").to_sym
      end

      def filter_parameter_pairs(pairs)
        pairs.select { |pair| blueprint.deserialize_parameter?(pair[0], pair[1]) }
      end
    end
  end
end
