module EdgycircleToolbox
  module Sonapi
    class Serializer
      attr_reader :blueprint

      def initialize(blueprint)
        @blueprint = blueprint
      end

      def call(object)
        {
          "type" => blueprint.type,
          "id" => object.id,
          "attributes" => collect_attributes(object)
        }
      end

      private
      def collect_attributes(object)
        Hash[
          blueprint.attribute_names(object).map do |attribute_name|
            [format_attribute_name(attribute_name), object.send(attribute_name)]
          end
        ]
      end

      def format_attribute_name(attribute_name)
        attribute_name.gsub("_", "-")
      end
    end
  end
end

